PBE.Util (Bouncy Castle Library 1.52 API Specification)
Date: 2015-03-01

org.bouncycastle.jcajce.provider.symmetric.util

## Class PBE.Util

- java.lang.Object
- - org.bouncycastle.jcajce.provider.symmetric.util.PBE.Util

- Enclosing interface:
    PBE

      public static class PBE.Util
      extends java.lang.Object

  uses the appropriate mixer to generate the key and IV if necessary.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PBE.Util()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static CipherParameters` | `makePBEMacParameters(BCPBEKey pbeKey, java.security.spec.AlgorithmParameterSpec spec)` generate a PBE based key suitable for a MAC algorithm, the key size is chosen according the MAC size, or the hashing algorithm, whichever is greater.
    `static CipherParameters` | `makePBEMacParameters(javax.crypto.spec.PBEKeySpec keySpec, int type, int hash, int keySize)` generate a PBE based key suitable for a MAC algorithm, the key size is chosen according the MAC size, or the hashing algorithm, whichever is greater.
    `static CipherParameters` | `makePBEParameters(BCPBEKey pbeKey, java.security.spec.AlgorithmParameterSpec spec, java.lang.String targetAlgorithm)` construct a key and iv (if necessary) suitable for use with a Cipher.
    `static CipherParameters` | `makePBEParameters(javax.crypto.spec.PBEKeySpec keySpec, int type, int hash, int keySize, int ivSize)` construct a key and iv (if necessary) suitable for use with a Cipher.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PBE.Util

          public PBE.Util()

  - ### Method Detail

    - #### makePBEParameters

          public static CipherParameters makePBEParameters(BCPBEKey pbeKey,
                                           java.security.spec.AlgorithmParameterSpec spec,
                                           java.lang.String targetAlgorithm)

      construct a key and iv (if necessary) suitable for use with a Cipher.

    - #### makePBEMacParameters

          public static CipherParameters makePBEMacParameters(BCPBEKey pbeKey,
                                              java.security.spec.AlgorithmParameterSpec spec)

      generate a PBE based key suitable for a MAC algorithm, the key size is chosen according the MAC size, or the hashing algorithm, whichever is greater.

    - #### makePBEParameters

          public static CipherParameters makePBEParameters(javax.crypto.spec.PBEKeySpec keySpec,
                                           int type,
                                           int hash,
                                           int keySize,
                                           int ivSize)

      construct a key and iv (if necessary) suitable for use with a Cipher.

    - #### makePBEMacParameters

          public static CipherParameters makePBEMacParameters(javax.crypto.spec.PBEKeySpec keySpec,
                                              int type,
                                              int hash,
                                              int keySize)

      generate a PBE based key suitable for a MAC algorithm, the key size is chosen according the MAC size, or the hashing algorithm, whichever is greater.